use Net::LDAP::Shell::Util qw(debug entry2ldif error);
use Net::LDAP::Shell qw(shellSearch);
use Getopt::Long;

sub main
{
	my ($usage,$results,$entry,@attrs,$optresult,$help,$helptext);

	$usage = "cat [-attr <attribute> ..] <ldap entry>\n";
	$optresult = GetOptions(
		'attr=s'		=> \@attrs,
		'help'		=> \$help,
	);

	$helptext =
"Cats the contents of an entry, in LDIF, to the screen.  Arguments
are treated as LDAP filters.
";

	unless ($optresult)
	{
		debug("bad args; exiting");
		warn $usage;
		return 1;
	}

	unless (@ARGV)
	{
		debug("no argv; exiting");
		warn $usage;
		return;
	}

	if ($help)
	{
		warn $usage,$helptext;
		return;
	}

	if (@attrs)
	{
		$CONFIG{'attrs'} = [ @attrs ];
	}
	else
	{
		$CONFIG{'attrs'} = [ qw(*) ];
	}
	$CONFIG{'filter'} = shift @ARGV;
	my @entries = shellSearch(%CONFIG) or 
		warn ("$CONFIG{'filter'}: not found.\n"), return;
	foreach $entry (@entries)
	{
		print entry2ldif($entry);
		print "\n";
	}
}

1;
